import options, times, uuids

type
  User* = object
    id*: UUID
    displayName*, email*, hashedPwd*: string

  ApiToken* = object
    id*, userId*: UUID
    name*, hashedToken*: string
    expires*: Option[DateTime]

  Measure* = object
    id*, userId*: UUID
    slug*, name*, description*, domainUnits*, rangeUnits*: string
    domainSource*, rangeSource*: Option[string]
    analysis*: seq[string]

  Value* = object
    id*, measureId*: UUID
    value*: int
    timestamp*: DateTime
    extData*: string

proc `$`*(u: User): string =
  return "User " & ($u.id)[0..6] & " - " & u.displayName & " <" & u.email & ">"

proc `$`*(tok: ApiToken): string =
  return "ApiToken " & ($tok.id)[0..6] & " - " & tok.name

proc `$`*(m: Measure): string =
  return "Measure " & ($m.id)[0..6] & " - " & m.slug

proc `$`*(v: Value): string =
  return "Value " & ($v.id)[0..6] & " - " & ($v.measureId)[0..6] & " = " & $v.value
